Increasing Code Coverage to Include Catch Blocks [Salesforce]

In Salesforce, it can sometimes be frustrating driving your Apex Class & Trigger Code Coverage up to get beyond the 75%, 80%, or 85%+ marks.  Some of the more difficult parts of that process can be covering all scenarios to achieve this. In particular, this post focuses on code not executed within the try-catch constructs count against the overall Code Coverage calculations. With a simple refactor, we can remedy that without changing the underlying functionality of the core class — just the test class.

The try-catch we will start with before our changes have the following format:

try {
// 1: core code to try
}
catch(Exception ex) {
// 2: code to execute when an Exception is thrown
}

If all goes well in your code and Test class, only “1” from above will be executed, leaving “2” to count against your code coverage. We can add to that as follows to fix that:

try {
// 1: core code to try
   if(Test.isRunningTest()) {
CalloutException e = new CalloutException();
e.setMessage('This is a constructed exception for testing and code coverage');
throw e;
}

}
catch(Exception ex) {
// 2: code to execute when an Exception is thrown
}

Essentially, throwing an Exception if-and-only-if a Test is running — AFTER the rest of the “try” has executed, giving maximum coverage. You may have to get creative and add different conditions in addition to the “Test.isRunningTest()” if there are multiple try-catch blocks within a single method to make sure, but I believe you get the picture.

Similarly, if a method returns a Boolean (or other type value), instead of having it return right then and there, declare a local variable that gets returned at the very end of the method. This can improve code readability as well. For example, the following:

try {
// 1: core code to try
if(Test.isRunningTest()) {
CalloutException e = new CalloutException();
e.setMessage('This is a constructed exception for testing and code coverage');
throw e;
}
}
catch(Exception ex) {
// 2: code to execute when an Exception is thrown
return false;
}
return true; // this does not get executed in Unit Tests as written

Would be refactored to:

Boolean returnValue = true;
try {
// 1: core code to try
if(Test.isRunningTest()) {
CalloutException e = new CalloutException();
e.setMessage('This is a constructed exception for testing and code coverage');
throw e;
}
}
catch(Exception ex) {
// 2: code to execute when an Exception is thrown
   returnValue = false;
}
return returnValue; // this will now be executed in Unit Tests as written

If you are in need of Salesforce help or need to add some experts to your project team, reach out to us through our Contact Form, we’d love to talk with you.

Leave a Reply

Your email address will not be published. Required fields are marked *